﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace aFrameEdit
{
    public partial class InstToneSaveAsForm : Form
    {
        private int selectToneIndex;

        public InstToneSaveAsForm(ProjectToneNameList nameList, int instNum)
        {
            InitializeComponent();
            selectToneIndex = instNum;
            foreach (string name in nameList.instNames)
            {
                instSaveAscomboBox.Items.Add(name);
            }
            instSaveAscomboBox.Text = nameList.instNames[selectToneIndex];
        }

        private void InstSaveAsSavebutton_Click(object sender, EventArgs e)
        {
            string instNumAndName = instSaveAscomboBox.Text;
            MainForm parent = (MainForm)this.Owner;
            string instName;
            string[] nameStrings = instNumAndName.Split(':');
            if (nameStrings.Length == 1) // empty, name only
            {
                if (instNumAndName.Length > 12)
                {
                    MessageBox.Show("Name length is longger.\nInput within 12 characters.");
                    return;
                }
                instName = nameStrings[0];
                instNumAndName = "I" + (selectToneIndex + 1).ToString("00") + ":" + nameStrings[0];
            }
            else
            {
                if (instNumAndName.Length > 16)
                {
                    MessageBox.Show("Name length is longger.\nInput within 16 characters include tone number.");
                    return;
                }
                instName = "";
                for (int i = 1; i < nameStrings.Length - 1; i++)
                {
                    instName += nameStrings[i] + ":";
                }
                instName += nameStrings[nameStrings.Length - 1];
            }

            parent.currentToneInfo.toneName.instName = instNumAndName;
            parent.currentToneData.instToneData.name = instName;
            parent.prjToneNameList.instNames[selectToneIndex] = instNumAndName;
            parent.changeEditBuffName(0, instName);

            parent.writeEditBuffToProject(0, selectToneIndex);
            parent.isToneInstEdited = false;
            parent.copyProjectToneNameList();
            parent.copyCurrentToneData();
            if (selectToneIndex != parent.currentToneInfo.instNum)
            {
                parent.changeToneNum(0, selectToneIndex);
                parent.isTonePairChanged = true;
                parent.setToneNameColor();
                parent.enableGroupOriginalAndSaveButton();
            }
            parent.currentToneInfo.instNum = selectToneIndex;
            parent.setComboBoxInstNameItems();
            parent.setComboBoxInstName(instNumAndName);
            parent.disableInstOriginalAndSaveButton();
            parent.enableComboboxInstName();
            parent.setInstNameLabelWhite();
            parent.clearInstChangedInfo();
            this.Dispose();
        }

        private void instSaveAscomboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            selectToneIndex = ((ComboBox)sender).SelectedIndex;
        }
    }
}
